## rustc 1.43.0+dfsg1+llvm

=== debian/changelog ===
rustc (1.43.0+dfsg1+llvm-1~exp1ubuntu2~18.04.1) bionic; urgency=medium

  * Backport to Bionic. (LP: #1876942)
  * Relax debhelper requirement.
  * Disable wasm build as build dependencies only available in 20.10.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 24 Jun 2020 12:59:50 +1200

rustc (1.43.0+dfsg1+llvm-1~exp1ubuntu2) groovy; urgency=medium

  * Fix mismerge preventing tests from running.
  * Backport patch fixing miscompliation and subsequent crash on s390x
    (adapted from https://src.fedoraproject.org/rpms/llvm/pull-request/49):
    - add debian/patches/0001-InstCombine-Fix-big-endian-miscompile-of-bitcast-zex.patch
    - update debian/patches/series

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Tue, 23 Jun 2020 19:35:09 +1200

rustc (1.43.0+dfsg1+llvm-1~exp1ubuntu1) groovy; urgency=medium

  * Merge from Debian NEW (LP: #1876942). Remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
      - update debian/control
    - Adjust debian/watch to include +llvm in upstream version.
      - update debian/watch
    - Add Build-Depends-Indep: libssl-dev
    - riscv64 support patches which no longer completely work:
      - Add more rustc patches from Debian.
      - Apply relevant llvm-toolchain-9 patches to the embedded llvm.
      - Avoid the LDFLAGS -latomic hacks from llvm-toolchain-9:
        - debian/patches/riscv64-atomic-fixes.patch: Fix libatomic detection for
        riscv64.
        - debian/patches/dsymutil-atomic.patch: Link dsymutil with -latomic.
  * Disable check for ~exp in version number.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 28 May 2020 07:59:18 +1200

rustc (1.43.0+dfsg1-1~exp1) UNRELEASED; urgency=medium

  * Drop sparc64 workaround. (Closes: #956413)
  * Drop stack-gap workaround for old kernels and rust versions.
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 26 Apr 2020 15:16:37 +0100

rustc (1.42.0+dfsg1+llvm-1ubuntu2) groovy; urgency=medium

  * Re-add riscv64 support patches which where accidentally dropped in
    previous upload and no longer completely work:
    - Add more rustc patches from Debian.
    - Apply relevant llvm-toolchain-9 patches to the embedded llvm.
    - Avoid the LDFLAGS -latomic hacks from llvm-toolchain-9:
      - debian/patches/riscv64-atomic-fixes.patch: Fix libatomic detection for
        riscv64.
      - debian/patches/dsymutil-atomic.patch: Link dsymutil with -latomic.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 21 May 2020 08:04:00 +1200

rustc (1.42.0+dfsg1+llvm-1ubuntu1) groovy; urgency=medium

  * Merge from Debian unstable (LP #1876942). Remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
      - update debian/control
    - Adjust debian/watch to include +llvm in upstream version.
      - update debian/watch
    - Add Build-Depends-Indep: libssl-dev

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 18 May 2020 20:29:59 +1200
