## rustc 1.46.0+dfsg1

=== debian/changelog ===
rustc (1.46.0+dfsg1-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.
  [changes introduced in 1.42.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Use the compiler itself rather than dpkg to detect DEB_BUILD_RUST_TYPE

 -- Raspbian forward porter <root@raspbian.org>  Sun, 06 Sep 2020 11:20:26 +0000

rustc (1.46.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 29 Aug 2020 16:54:36 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp5) experimental; urgency=medium

  * Fix rust-gdb install path. (Closes: #968279)
  * Drop powerpc allowed-failures to 12. (Closes: #955774)
  * Update d-fix-mips64el-bootstrap.patch for newer LLVM.

 -- Ximin Luo <infinity0@debian.org>  Fri, 14 Aug 2020 23:45:25 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp4) experimental; urgency=medium

  * Move cross-linker Depends to Recommends - for cross-compiling support
    libraries should never hard-depend on toolchains. This also allows us to
    add the usual M-A annotations for libraries.

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Aug 2020 18:16:16 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp3) experimental; urgency=medium

  * Drop "-cross" suffix from libstd naming, after discussion with Helmut
    Grohne. Since libstd-rust-dev-wasm-cross is not yet in stable and only
    has 4 installed users, we do not retain a migration package. 

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Aug 2020 14:27:54 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp2) experimental; urgency=medium

  * Add support for cross-compiling to windows. See README.Debian for details.
    Currently only 64-bit works, we are waiting on #540782 for 32-bit.

 -- Ximin Luo <infinity0@debian.org>  Sun, 09 Aug 2020 03:52:34 +0100

rustc (1.46.0~beta.2+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Fri, 07 Aug 2020 00:15:46 +0100

rustc (1.45.0+dfsg1-2) unstable; urgency=medium

  * Add some more big-endian test patches.
  * Backport some patches to fix some testsuite ICEs.

 -- Ximin Luo <infinity0@debian.org>  Thu, 06 Aug 2020 21:11:39 +0100

rustc (1.45.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Wed, 05 Aug 2020 21:41:39 +0100

rustc (1.45.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 27 Jul 2020 17:45:24 +0100

rustc (1.44.1+dfsg1-3) unstable; urgency=medium

  * Fix patch for line numbers on little-endian arches.

 -- Ximin Luo <infinity0@debian.org>  Tue, 28 Jul 2020 21:51:36 +0100

rustc (1.44.1+dfsg1-2) unstable; urgency=medium

  * Ignore tests that assume little-endian on big-endian arches.
    See upstream #74829 for details.

 -- Ximin Luo <infinity0@debian.org>  Tue, 28 Jul 2020 21:20:24 +0100

rustc (1.44.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Backport a typenum fix for i386.
  * Work around upstream #74786 involving debuginfo maps.

 -- Ximin Luo <infinity0@debian.org>  Mon, 27 Jul 2020 13:15:20 +0100

rustc (1.44.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Jul 2020 18:04:42 +0100
