=== debian/control ===
--- 
+++ 
@@ -1,43 +1,45 @@
 Source: rustc
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>
 # :native annotations are to support cross-compiling, see README.Debian
-Build-Depends: debhelper (>= 9),
-               debhelper-compat (= 11),
-               dpkg-dev (>= 1.17.14),
-               python3:native,
-               cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
-               rustc:native (>= 1.42.0+dfsg) <!pkg.rustc.dlstage0>,
-               rustc:native (<= 1.43.0++)    <!pkg.rustc.dlstage0>,
-               cmake (>= 3.0) | cmake3,
+Build-Depends:
+ debhelper (>= 9),
+ debhelper-compat (= 12),
+ dpkg-dev (>= 1.17.14),
+ python3:native,
+ cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
+ rustc:native (>= 1.45.0+dfsg) <!pkg.rustc.dlstage0>,
+ rustc:native (<= 1.46.0++)    <!pkg.rustc.dlstage0>,
+ llvm-10-dev:native,
+ llvm-10-tools:native,
+ gcc-mingw-w64-x86-64-win32:native [amd64] <!nowindows>,
+# FIXME #540782 gcc-mingw-w64-i686-win32:native [i386] <!nowindows>,
+ libllvm10,
+ cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
-               pkg-config,
+ pkg-config,
 # this is sometimes needed by rustc_llvm
-               zlib1g-dev:native,
-               zlib1g-dev,
+ zlib1g-dev:native,
+ zlib1g-dev,
 # used by rust-installer
-               liblzma-dev:native,
-# Required for llvm build
-               autotools-dev,
-               m4,
+ liblzma-dev:native,
 # test dependencies:
-               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
-               git <!nocheck>,
-               procps <!nocheck>,
+ binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
+ git <!nocheck>,
+ procps <!nocheck>,
 # below are optional tools even for 'make check'
-               gdb (>= 7.12) <!nocheck>,
-               libc6-dbg [armhf],
+ gdb (>= 7.12) <!nocheck>,
 # Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
-               curl <pkg.rustc.dlstage0>,
-               ca-certificates <pkg.rustc.dlstage0>,
+ curl <pkg.rustc.dlstage0>,
+ ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
- libssl-dev,
-Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
+ wasi-libc (>= 0.0~git20200319.9efc2f4~~) <!nowasm>,
+ wasi-libc (<= 0.0~git20200319.9efc2f4++) <!nowasm>,
+Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 4.2.1
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://salsa.debian.org/rust-team/rust.git
@@ -49,10 +51,10 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: cargo (>= 0.44.0~~), cargo (<< 0.45.0~~), rust-gdb | rust-lldb
-Suggests: rust-doc, rust-src, lld-9
-Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
-Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
+Recommends: cargo (>= 0.47.0~~), cargo (<< 0.48.0~~), rust-gdb | rust-lldb
+Suggests: rust-doc, rust-src, lld-10
+Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
+Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Description: Rust systems programming language
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -66,7 +68,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.43
+Package: libstd-rust-1.46
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -85,13 +87,14 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
  .
- This package contains the standard Rust libraries, built as dylibs.
+ This package contains the standard Rust libraries, built as dylibs,
+ needed to run dynamically-linked Rust programs (-C prefer-dynamic).
 
 Package: libstd-rust-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.43 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.46 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -105,8 +108,62 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
  .
- This package contains development files necessary to use the standard
- Rust libraries.
+ This package contains development files for the standard Rust libraries,
+ needed to compile Rust programs. It may also be installed on a system
+ of another host architecture, for cross-compiling to this architecture.
+
+Package: libstd-rust-dev-windows
+Section: libdevel
+# FIXME #540782 Architecture: amd64 i386
+Architecture: amd64
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Recommends:
+ gcc-mingw-w64-x86-64-win32 [amd64],
+# FIXME #540782 gcc-mingw-w64-i686-win32 [i386],
+Build-Profiles: <!nowindows>
+Description: Rust standard libraries - development files
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains the standard Rust libraries including development files,
+ needed to cross-compile Rust programs to the *-pc-windows-gnu target
+ corresponding to the architecture of this package.
+
+Package: libstd-rust-dev-wasm32
+Section: libdevel
+Architecture: all
+Multi-Arch: foreign
+Depends: ${shlibs:Depends}, ${misc:Depends}
+# Embeds wasi-libc so doesn't need to depend on it
+# None of its licenses require source redistrib, so no need for Built-Using
+Recommends: lld-10
+Build-Profiles: <!nowasm>
+Description: Rust standard libraries - development files
+ Rust is a curly-brace, block-structured expression language.  It
+ visually resembles the C language family, but differs significantly
+ in syntactic and semantic details.  Its design is oriented toward
+ concerns of "programming in the large", that is, of creating and
+ maintaining boundaries - both abstract and operational - that
+ preserve large-system integrity, availability and concurrency.
+ .
+ It supports a mixture of imperative procedural, concurrent actor,
+ object-oriented and pure functional styles.  Rust also supports
+ generic programming and meta-programming, in both static and dynamic
+ styles.
+ .
+ This package contains the standard Rust libraries including development files,
+ needed to cross-compile Rust programs to the wasm32-unknown-unknown and
+ wasm32-wasi targets.
 
 Package: rust-gdb
 Architecture: all
@@ -132,7 +189,7 @@
 Package: rust-lldb
 Architecture: all
 # When updating, also update rust-lldb.links
-Depends: lldb-9, ${misc:Depends}, python3-lldb-9
+Depends: lldb-10, ${misc:Depends}, python3-lldb-10
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It
