=== debian/rules ===
--- 
+++ 
@@ -14,26 +14,27 @@
 LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')
 
 include /usr/share/dpkg/buildflags.mk
-# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
-RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
-RUSTFLAGS += --cap-lints warn --remap-path-prefix=$(CURDIR)=/usr/src/rustc-$(RUST_LONG_VERSION)
-export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
+export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
 export CARGO_HOME = $(CURDIR)/debian/cargo
 
 # Defines DEB_*_RUST_TYPE triples
 include debian/architecture.mk
 export DEB_HOST_RUST_TYPE
 
-# Let rustbuild control whether LLVM is compiled with debug symbols, rather
-# than compiling with debug symbols unconditionally, which will fail on
-# 32-bit architectures
-CFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-CXXFLAGS := $(shell echo $(CFLAGS) | sed -e 's/\-g//')
-
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
+
+# Use system LLVM (comment out to use vendored LLVM)
+LLVM_VERSION = 10
+OLD_LLVM_VERSION = 9
+# Make it easier to test against a custom LLVM
+ifneq (,$(LLVM_DESTDIR))
+LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
+LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
+export LD_LIBRARY_PATH
+endif
 
 RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py
 RUSTBUILD_FLAGS = --config debian/config.toml -vvv --on-fail env
@@ -105,7 +106,32 @@
   BUILD_DOCS := false
 endif
 
-BUILD_WASM := false
+BUILD_WASM := true
+ifneq (,$(findstring nowasm,$(DEB_BUILD_PROFILES)))
+  BUILD_WASM := false
+endif
+
+# FIXME: 32-bit doesn't work yet, https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=540782#64
+#WINDOWS_SUPPORT := amd64 i386
+WINDOWS_SUPPORT := amd64
+BUILD_WINDOWS := true
+ifneq (,$(findstring nowindows,$(DEB_BUILD_PROFILES)))
+  BUILD_WINDOWS := false
+endif
+ifeq (,$(filter $(DEB_HOST_ARCH), $(WINDOWS_SUPPORT)))
+  BUILD_WINDOWS := false
+else
+  ifeq (,$(filter $(DEB_BUILD_ARCH), $(WINDOWS_SUPPORT)))
+    ifeq (true,$(BUILD_WINDOWS))
+      $(error cannot cross-compile from $(DEB_BUILD_ARCH) to $(DEB_HOST_ARCH), unless "nowindows" is in DEB_BUILD_PROFILES)
+    endif
+  endif
+  ifeq (i386,$(DEB_HOST_ARCH))
+    WINDOWS_ARCH := i686
+  else
+    WINDOWS_ARCH := x86_64
+  endif
+endif
 
 MAKE_OPTIMISATIONS := true
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -123,6 +149,10 @@
 
 %:
 	$(SYSTEM_WORKAROUNDS) dh $@ --parallel
+
+.PHONY: .dbg-windows
+.dbg-windows:
+	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)
 
 .PHONY: build
 build:
@@ -144,12 +174,14 @@
 		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
 		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
 		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
+		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
+		-DLLVM_VERSION="$(LLVM_VERSION)" \
 		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
 		"$<" > "$@"
 	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
 	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 # Work around low-memory (32-bit) architectures: https://github.com/rust-lang/rust/issues/45854
-ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel i386 mips mipsel powerpc powerpcspe))
+ifneq (,$(filter $(DEB_BUILD_ARCH), armhf armel mips mipsel powerpc powerpcspe))
 	sed -i -e 's/^debuginfo-level = .*/debuginfo-level = 0/g' "$@"
 endif
 
@@ -158,30 +190,8 @@
 		"$<" > "$@"
 
 debian/dh_auto_configure.stamp: debian/config.toml
+	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
+	! grep --color=always -i 'll\(..\|d\)-\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog --exclude=copyright --exclude='*.patch' --exclude-dir='.debhelper' -R debian
 	# fail the build if we accidentally vendored openssl, indicates we pulled in unnecessary dependencies
 	test ! -e vendor/openssl
-	# fail the build if we didn't update d-ignore-error-detail-diff.patch
-	! grep -Ri '\$$SRC_DIR' src/test/
-	$(PRECONFIGURE_CHECK)
-	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
-	# work around #842634
-	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
-	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
-	# work around https://github.com/rust-lang/rust/issues/59264
-	# We patched some crates so have to rm the checksums
-	find vendor -name .cargo-checksum.json -execdir "$(CURDIR)/debian/prune-checksums" "{}" +
-	# Link against system liblzma, see https://github.com/alexcrichton/xz2-rs/issues/16
-	echo 'fn main() { println!("cargo:rustc-link-lib=lzma"); }' > vendor/lzma-sys/build.rs
-	# We don't run ./configure because we use debian/config.toml directly
-	ln -sf debian/config.toml config.toml
-	touch "$@"
-
-override_dh_auto_configure-arch: debian/dh_auto_configure.stamp
-override_dh_auto_configure-indep: debian/dh_auto_configure.stamp
-ifeq (true,$(BUILD_DOCS))
-# Change config.toml now and not later, since that might trigger a rebuild
-	sed -i -e 's/^docs = false/docs = true/' debian/config.toml
-endif
-
-override_dh_auto_clean:
-	$(RM) -rf build tmp .cargo debian/cargo_home config.stamp config.mk Makefile
+	# fail the build if our version contains ~exp and we are not releasing to experimental
