## rustc 1.47.0%2Bdfsg1

=== debian/changelog ===
rustc (1.47.0+dfsg1-1+rpi1) bullseye-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.
  [changes introduced in 1.42.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Use the compiler itself rather than dpkg to detect DEB_BUILD_RUST_TYPE

 -- Raspbian forward porter <root@raspbian.org>  Tue, 17 Nov 2020 19:31:32 +0000

rustc (1.47.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Update to LLVM 11.
  * Ignore more tests on big-endian.

 -- Ximin Luo <infinity0@debian.org>  Sat, 07 Nov 2020 21:21:03 +0000

rustc (1.47.0~beta.2+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 05 Sep 2020 16:11:16 +0100
