=== debian/control ===
--- 
+++ 
@@ -12,13 +12,13 @@
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
- rustc:native (>= 1.45.0+dfsg) <!pkg.rustc.dlstage0>,
- rustc:native (<= 1.46.0++)    <!pkg.rustc.dlstage0>,
- llvm-10-dev:native,
- llvm-10-tools:native,
- gcc-mingw-w64-x86-64-win32:native [amd64] <!nowindows>,
-# FIXME #540782 gcc-mingw-w64-i686-win32:native [i386] <!nowindows>,
- libllvm10,
+ rustc:native (>= 1.46.0+dfsg) <!pkg.rustc.dlstage0>,
+ rustc:native (<= 1.47.0++)    <!pkg.rustc.dlstage0>,
+ llvm-11-dev:native,
+ llvm-11-tools:native,
+ gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
+# FIXME #540782 gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
+ libllvm11,
  cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
  pkg-config,
@@ -37,8 +37,9 @@
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
- wasi-libc (>= 0.0~git20200319.9efc2f4~~) <!nowasm>,
- wasi-libc (<= 0.0~git20200319.9efc2f4++) <!nowasm>,
+ wasi-libc (>= 0.0~git20200731.215adc8~~) <!nowasm>,
+ wasi-libc (<= 0.0~git20200731.215adc8++) <!nowasm>,
+ clang-11:native,
 Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 4.2.1
 Homepage: http://www.rust-lang.org/
@@ -51,8 +52,8 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
-Recommends: cargo (>= 0.47.0~~), cargo (<< 0.48.0~~), rust-gdb | rust-lldb
-Suggests: rust-doc, rust-src, lld-10
+Recommends: cargo (>= 0.48.0~~), cargo (<< 0.49.0~~), rust-gdb | rust-lldb
+Suggests: rust-doc, rust-src, lld-11
 Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
 Description: Rust systems programming language
@@ -68,7 +69,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.46
+Package: libstd-rust-1.47
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -94,7 +95,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.46 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.47 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -119,8 +120,8 @@
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends:
- gcc-mingw-w64-x86-64-win32 [amd64],
-# FIXME #540782 gcc-mingw-w64-i686-win32 [i386],
+ gcc-mingw-w64-x86-64-posix [amd64],
+# FIXME #540782 gcc-mingw-w64-i686-posix [i386],
 Build-Profiles: <!nowindows>
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
@@ -146,7 +147,8 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 # Embeds wasi-libc so doesn't need to depend on it
 # None of its licenses require source redistrib, so no need for Built-Using
-Recommends: lld-10
+Recommends: lld-11
+Suggests: clang-11
 Build-Profiles: <!nowasm>
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
@@ -189,7 +191,7 @@
 Package: rust-lldb
 Architecture: all
 # When updating, also update rust-lldb.links
-Depends: lldb-10, ${misc:Depends}, python3-lldb-10
+Depends: lldb-11, ${misc:Depends}, python3-lldb-11
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It
